<template>
  <div class="drawable">
    <div :class="`drawable-image  ${isUploaded ? 'drawable-image-uploaded' : ''}`">
      <div
        :class="`drawable-stage-wrapper ${isUploaded ? 'drawable-stage-padding' : ''}`"
        :style="isUploaded ? `background: url('${require('../assets/img/scratch_area.png')}') no-repeat center center` : ''"
      >
        <div ref="container" id="drawable-stage">
          <canvas id="drawable-canvas"></canvas>
        </div>
      </div>
      <div v-if="contentText.length > 0" class="drawable-btns">
        <drawable-upload-component v-if="!isUploaded" @upload="onCaptureFile" />
        <drawable-filter-component
          v-else
          @zoom="onChangeZoom"
          @contrast="onChangeContrast"
          @color="onChangeColor"
        />
        <action-buttons-component
          v-if="isUploaded"
          :hasCancelBtn="true"
          @share="onShare"
          @download="onDownloadImage"
          @cancel="onDrawableImageCancel"
        />
      </div>
    </div>
    <div class="drawable-edit-text">
      <input ref="text" type="text" v-model="contentText" />
    </div>
    <div class="top-arrow">
      <button @click="goBackToVisual">
        <img
          class="animated infinite fadeInDown delay-2s"
          src="../assets/img/scroll_down.png"
          alt="scroll up"
        />
      </button>
    </div>
    <div class="bottom-arrow">
      <button @click="openMvPopup">
        <img
          class="animated infinite fadeInDown delay-2s"
          src="../assets/img/scroll_down.png"
          alt="scroll down"
        />
      </button>
    </div>
  </div>
</template>

<script lang="ts">
import { Component, Vue, Watch } from 'vue-property-decorator';
import { fabric } from 'fabric';
import { DrawImageService, CommonService } from '../services';
import DrawableFilterComponent from './DrawableFilter.vue';
import DrawableUploadComponent from './DrawableUpload.vue';
import ActionButtonsComponent from './ActionButtons.vue';
import { uploadModule } from '../store/upload/const';
import {
  Sharer,
  commonModule,
  SlideName,
  Orientation
} from '../store/common/const';
import { SHARE_HASHTAG } from '../constants';

@Component({
  components: {
    DrawableFilterComponent,
    DrawableUploadComponent,
    ActionButtonsComponent
  }
})
export default class DrawableComponent extends Vue {
  width: number = 1000;
  height: number = 1000;
  scale: number = 1;
  mainTextFontSize: number = 180;

  // Fabric
  canvas!: fabric.Canvas;
  watermark!: fabric.Image;
  canvasCursor!: fabric.Rect;
  mainText!: fabric.Text;
  placeholderText!: fabric.Rect;
  groupText!: fabric.Group;
  backgroundImg!: fabric.Image;

  contentText: string = '';
  isUploaded: boolean = false;
  contrast: number = 0;
  backgroundImgDefaultScaleX: number = 0;
  intervalCursor;
  watermarkImg!: HTMLImageElement;
  lightPattern!: fabric.Pattern;
  darkPattern!: fabric.Pattern;

  @uploadModule.State('uploadedImageUrl') uploadedImageUrl!: string;
  @commonModule.State('orientation') orientation!: Orientation;

  @uploadModule.Action('uploadImage') uploadImage!: (imgData: string) => string;
  @commonModule.Action('toggleMvModal')
  toggleMvModal!: (isOpen: boolean) => void;
  @commonModule.Action('changeToSlide')
  changeToSlide!: (slide: SlideName) => void;
  @commonModule.Action('canSwipe')
  protected canSwipe!: (swiped: boolean) => void;

  @Watch('orientation')
  orientationChange() {
    const text: any = this.$refs.text;
    if (text) {
      text.blur();
    }
  }

  @Watch('contentText')
  onChangeText() {
    this.mainText.set('text', this.contentText);
    this.canvas.renderAll();
    this.setFontSizeFitToWidth();
    this.canvas.renderAll();
  }

  setFontSizeFitToWidth() {
    let desiredFontSize =
      (this.mainText.fontSize * this.width * 0.8) / this.mainText.width;
    if (desiredFontSize > this.mainTextFontSize) {
      desiredFontSize = this.mainTextFontSize;
    }
    this.mainText.fontSize = desiredFontSize;

    // Cursor position
    if (this.mainText.width > this.width * 0.8) {
      this.canvasCursor.left = this.width - this.width * 0.1;
    } else {
      this.canvasCursor.left = this.width / 2 + this.mainText.width / 2 + 10;
    }
    this.canvasCursor.set('height', this.mainText.height);
  }

  protected onMovingBackground() {
    let top = this.backgroundImg.top;
    let bottom = top + this.backgroundImg.height * this.backgroundImg.scaleY;
    let left = this.backgroundImg.left;
    let right = left + this.backgroundImg.width * this.backgroundImg.scaleX;

    var topBound = this.canvas.top;
    var bottomBound = topBound + this.height;
    var leftBound = this.canvas.left;
    var rightBound = leftBound + this.width;

    if (top > topBound) {
      this.backgroundImg.set('top', topBound);
    }
    if (bottom < bottomBound) {
      this.backgroundImg.set('top', bottomBound - topBound - (bottom - top));
    }
    if (left > leftBound) {
      this.backgroundImg.set('left', leftBound);
    }
    if (right < rightBound) {
      this.backgroundImg.set('left', rightBound - leftBound - (right - left));
    }
  }

  protected async onCaptureFile(fileData?) {
    // Add group for text
    this.groupText = new fabric.Group([this.watermark, this.mainText], {
      originX: 'center',
      originY: 'center',
      left: this.width / 2,
      top: this.height / 2,
      width: this.width * 0.8
    });
    this.canvas.clear().renderAll();
    this.canvas.add(this.groupText);

    let bg;
    if (fileData) {
      bg = await DrawImageService.draw(fileData);
    } else {
      bg = await DrawImageService.draw(require('../assets/img/black_bg.png'));
    }

    let { width, height } = bg;

    this.backgroundImg = new fabric.Image(bg, {
      left: 0,
      top: 0,
      hasControls: false,
      hasBorders: false,
      name: 'background'
    });

    if (width > height) {
      this.backgroundImg.scaleToHeight(this.height);
    } else {
      this.backgroundImg.scaleToWidth(this.width);
    }

    this.backgroundImg.on({ moving: this.onMovingBackground });

    this.canvas.add(this.backgroundImg);
    this.canvas.sendToBack(this.backgroundImg);
    this.canvas.bringToFront(this.groupText);

    this.backgroundImgDefaultScaleX = this.backgroundImg.scaleX;
    this.isUploaded = true;
    clearInterval(this.intervalCursor);
  }

  protected onChangeZoom(value: number) {
    this.backgroundImg.set({
      scaleX: this.backgroundImgDefaultScaleX * value,
      scaleY: this.backgroundImgDefaultScaleX * value
    });
    this.onMovingBackground();
    this.canvas.renderAll();
  }

  protected applyFilters(img, index, filter) {
    img.filters[index] = filter;
    img.applyFilters();
    this.canvas.renderAll();
  }

  protected onChangeContrast(value: number) {
    this.applyFilters(
      this.backgroundImg,
      0,
      new fabric.Image.filters.Contrast({
        contrast: value
      })
    );
  }

  protected onChangeColor(color: string) {
    this.mainText.set(
      'fill',
      color === 'white' ? this.lightPattern : this.darkPattern
    );
    this.applyFilters(
      this.watermark,
      0,
      new fabric.Image.filters.Contrast({
        contrast: color === 'white' ? 1 : -10
      })
    );
  }

  protected onMainTextClick() {
    const text: any = this.$refs.text;
    if (text) {
      text.focus({ preventScroll: true });
    }
  }

  protected setCanvasScaledHeight(width, height) {
    let scale = height / this.canvas.getHeight();
    let zoom = this.canvas.getZoom();
    zoom *= scale;

    this.canvas.setDimensions({ width, height });
    this.canvas.setZoom(zoom);
    this.scale = scale;
  }

  protected changeRect() {
    const { container } = this.$refs;
    if (!container) return;

    let width = (container as HTMLElement).offsetWidth;
    let height = (container as HTMLElement).offsetHeight;
    let ratio = this.canvas.getWidth() / this.canvas.getHeight();

    if (width / height > ratio) {
      width = height * ratio;
    } else {
      height = width / ratio;
    }

    this.setCanvasScaledHeight(width, height);
  }

  onDrawableImageCancel() {
    this.contentText = '';
    this.canvas.dispose();
    this.init();
  }

  async onUploadImage() {
    this.setCanvasScaledHeight(1200, 1200);
    let data = this.canvas.toDataURL({
      format: 'jpeg',
      multiplier: 1,
      left: 0,
      top: 0
    });
    this.changeRect();
    let url = await this.uploadImage(data);
    return url;
  }

  async onDownloadImage() {
    let url = await this.onUploadImage();
    CommonService.downloadImageFromUrl(window.location.origin + url);
  }

  async onShare() {
    await this.onUploadImage();
    CommonService.shareToFacebook(
      `http://www.facebook.com/sharer/sharer.php?u=${window.location.origin}${this.uploadedImageUrl}&hashtag=%23${SHARE_HASHTAG}`
    );
  }

  openMvPopup() {
    this.toggleMvModal(true);
  }

  goBackToVisual() {
    this.canSwipe(true);
    this.changeToSlide(SlideName.Visual);
  }

  async mounted() {
    fabric.textureSize = 2.5 * 1024 * 1024;
    const [watermark, mask, maskDark] = await Promise.all([
      DrawImageService.draw(require('../assets/img/watermark-top.png')),
      DrawImageService.draw(require('../assets/img/mask.png')),
      DrawImageService.draw(require('../assets/img/mask-dark.png'))
    ]);

    this.lightPattern = new fabric.Pattern({ source: mask, repeat: 'repeat' });
    this.darkPattern = new fabric.Pattern({
      source: maskDark,
      repeat: 'repeat'
    });
    this.watermarkImg = watermark;

    this.init();
  }

  protected init() {
    // Set main canvas
    this.canvas = new fabric.Canvas('drawable-canvas', {
      preserveObjectStacking: true,
      controlsAboveOverlay: true,
      selectionCompatibility: true,
      top: 0,
      left: 0,
      selection: false
    });
    this.canvas.setWidth(this.width);
    this.canvas.setHeight(this.height);
    this.canvas.on({
      'touch:gesture': evt => {
        if (evt.target.name === 'background') {
          if (evt.e.touches && evt.e.touches.length >= 2) {
            this.backgroundImg.set({
              angle: 0,
              scaleX: this.backgroundImgDefaultScaleX,
              scaleY: this.backgroundImgDefaultScaleX
            });
            this.onMovingBackground();
          }
        }
      }
    });

    // Responsive canvas
    this.changeRect();
    window.addEventListener('resize', this.changeRect);

    // Add Fabric watermark
    this.watermark = new fabric.Image(this.watermarkImg, {
      left: this.width / 2,
      top: this.height / 2,
      originX: 'center',
      originY: 'bottom',
      lockMovementX: true,
      lockMovementY: true,
      hasControls: false,
      hasBorders: false,
      selectable: false
    });
    this.watermark.scaleToWidth(this.width * 0.8);

    // Add Fabric main text
    this.mainText = new fabric.Text(this.contentText, {
      left: this.width / 2,
      top: this.height / 2 + 40,
      fill: this.lightPattern,
      fontFamily: 'Saira Stencil One',
      textAlign: 'center',
      fixedWidth: this.width * 0.8,
      fontSize: this.mainTextFontSize,
      originX: 'center',
      originY: 'top',
      lockMovementX: true,
      lockMovementY: true,
      hasControls: false,
      hasBorders: false,
      selectable: false
    });

    // Add cursor
    this.canvasCursor = new fabric.Rect({
      left: this.width / 2 + this.mainText.width / 2,
      top: this.mainText.top,
      width: 10,
      height: this.mainText.height,
      fill: '#f88f00',
      originX: 'center',
      lockMovementX: true,
      lockMovementY: true,
      hasControls: false,
      hasBorders: false,
      selectable: false
    });

    // Add placeholder text
    this.placeholderText = new fabric.Rect({
      left: this.width / 2,
      top: this.height / 2 + 10,
      originX: 'center',
      originY: 'top',
      fill: 'rgba(0,0,0,0)',
      width: this.width * 0.8,
      height: this.mainText.height,
      lockMovementX: true,
      lockMovementY: true,
      hasControls: false,
      hasBorders: false,
      selectable: false
    });

    this.watermark.on('mouseup', this.onMainTextClick);
    this.mainText.on('mouseup', this.onMainTextClick);
    this.placeholderText.on('mouseup', this.onMainTextClick);

    // Twinkle cursor
    let opacity = 0;
    this.intervalCursor = setInterval(() => {
      this.canvasCursor.animate('opacity', opacity, {
        duration: 500,
        onChange: this.canvas.renderAll.bind(this.canvas),
        easing: fabric.util.ease['easingInOutQuad']
      });
      opacity = opacity === 1 ? 0 : 1;
    }, 500);

    this.canvas.add(this.watermark);
    this.canvas.add(this.mainText);
    this.canvas.add(this.canvasCursor);
    this.canvas.add(this.placeholderText);
    this.setFontSizeFitToWidth();

    this.isUploaded = false;
  }
}
</script>

<style lang="scss" scoped>
.drawable {
  width: 100%;
  height: 100vh;
  min-height: 370px;
  position: relative;
  background: url('../assets/img/drawable-bg.jpg') no-repeat center center;
  background-size: cover;
  display: flex;
  justify-content: center;
  align-items: center;

  .drawable-edit-text {
    position: absolute;
    top: 0;
    left: -50%;
    z-index: 1;
  }

  .drawable-image {
    position: relative;
    z-index: 99;
    height: 80%;
    display: flex;
    flex-direction: column;
    justify-content: center;
    align-items: center;

    .drawable-stage-wrapper {
      background-size: contain !important;

      &.drawable-stage-padding {
        padding: 10vw;
      }
    }

    #drawable-stage {
      z-index: 999;
      width: 70vw;
      height: 70vw;
      display: flex;
      justify-content: center;
      align-items: center;
    }

    .drawable-content {
      display: flex;
      justify-content: center;
      align-items: center;
    }
  }

  .drawable-btns {
    position: relative;
    z-index: 99999;
    width: 100%;
  }

  .top-arrow {
    position: absolute;
    top: 8vh;
    left: 0;
    width: 100%;
    z-index: 9999;

    button {
      display: inline-block;
      transform: rotate(180deg);
      -webkit-transform: rotate(180deg);
      -moz-transform: rotate(180deg);
      -o-transform: rotate(180deg);
    }

    img {
      height: 4vh;
    }
  }

  .bottom-arrow {
    position: absolute;
    bottom: 0;
    left: 0;
    width: 100%;
    z-index: 9999;

    img {
      height: 4vh;
    }
  }
}

@include Orientation(Landscape) {
  .drawable {
    background: black url('../assets/img/spark_smoke_editable_landscape.jpg')
      no-repeat center bottom;
    background-size: cover;

    .drawable-image {
      margin: 0 5vh;

      &.drawable-image-uploaded {
        flex-direction: row;
      }

      .drawable-stage-wrapper {
        &.drawable-stage-padding {
          padding: 10vh;
        }
      }

      #drawable-stage {
        width: 70vh;
        height: 70vh;
      }
    }

    .top-arrow {
      top: 13vh;
    }
  }
}
</style>